package org.kropp.tests;

import org.kropp.index.Index;
import org.kropp.util.xml.XMLIndexFactory;

import junit.framework.AssertionFailedError;
import junit.framework.TestCase;

import net.sf.xanswer.indexing.IndexException;

public class IndexFactoryTest extends TestCase {
	private Index myTestIndex;

	private boolean failed;

	public void testCreateIndex() {
		myTestIndex = XMLIndexFactory.getInstance().createIndex("test.xml");

		assertEquals("-1", myTestIndex.toString());
	}

	public void testOpenIndex() {
		try {
			myTestIndex = XMLIndexFactory.getInstance().openIndex("notfound",
					"");
		} catch (IndexException e) {
			failed = true;
		}

		if (!failed) {
			throw new AssertionFailedError("Opened non-existent index");
		}
	}

	public void setUp() {
		failed = false;
	}

	public void tearDown() {
		if (!failed) {
			myTestIndex.delete();
		}
	}
}
