package org.kropp.util;

import junit.framework.TestCase;

public class BTreeLeafNodeTest extends TestCase {
	public void testNextPrevious() {
		BTreeLeafNode node = new BTreeLeafNode<Integer, String>(5, null);
		assertNull(node.getPrevious());
		assertNull(node.getNext());
	}

	public void testPut() {
		BTreeNode<Integer, String> parent = new BTreeNode<Integer, String>(5, null);
		BTreeLeafNode<Integer, String> node = new BTreeLeafNode<Integer, String>(5, parent);
		parent.addNode(3, node);
		node.put(3, "Test 3");
		node.put(3, "Test 1");

		assertEquals("Test 1", node.getValue(3));
	}
	
	public void testIndexOf() {
		BTreeNode<Integer, String> parent = new BTreeNode<Integer, String>(5, null);
		BTreeLeafNode<Integer, String> node = new BTreeLeafNode<Integer, String>(5, parent);
		parent.addNode(3, node);
		node.put(3, "Test 3");
		node.put(4, "Test 4");
		node.put(2, "Test 2");
		node.put(0, "Test 0");
		node.put(1, "Test 1");

		for(int i = 0; i < 5; i++) {
			assertEquals(i, node.indexOf(i));
		}
		
		assertEquals(0, node.indexOf(-1));
		assertEquals(4, node.indexOf(10));
	}
	
	public void testGet() {
		BTreeNode<Integer, String> parent = new BTreeNode<Integer, String>(5, null);
		BTreeLeafNode<Integer, String> node = new BTreeLeafNode<Integer, String>(5, parent);
		parent.addNode(4, node);
		for(int i = 4; i >= 0; i--) {
			node.put(i, "Test " + i);
		}

		for(int i = 0; i < 5; i++) {
			assertEquals("Test " + i, node.getValue(i));
		}
	}
}
